/// O(n * log n)
#include <fstream>
using namespace std;

const int MaxN = 100000;
int a[MaxN], n;
int tmp[MaxN];

void ReadArray();
void Merge(int st, int dr);
void Interclass(int st, int m, int dr);
void WriteArray();

int main()
{
    ReadArray();
    Merge(0, n - 1);
    WriteArray();
    return 0;
}

void Merge(int st, int dr)
{
    if (st == dr) return;
    int m = (st + dr) / 2;
    Merge(st, m);
    Merge(m + 1, dr);
    Interclass(st, m, dr);
}

void Interclass(int st, int m, int dr)
{
    int i = st, j = m + 1, k = 0;

    while (i <= m && j <= dr)
        if (a[i] < a[j])
            tmp[k++] = a[i++];
        else
            tmp[k++] = a[j++];

    while (i <= m)
        tmp[k++] = a[i++];
    while (j <= dr)
        tmp[k++] = a[j++];

    for (int i = st; i <= dr; ++i)
        a[i] = tmp[i - st];
}

void ReadArray()
{
    ifstream fin("sir.in");
    fin >> n;
    for (int i = 0; i < n; ++i)
        fin >> a[i];
    fin.close();
}

void WriteArray()
{
    ofstream fout("sir.out");

    for (int i = 0; i < n; ++i)
        fout << a[i] << ' ';
    fout.close();
}
